//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%43A8601201D1.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%43A8601201D1.cm

//## begin module%43A8601201D1.cp preserve=no
//## end module%43A8601201D1.cp

//## Module: UniqueEnergy%43A8601201D1; Package body
//## Subsystem: XSModel::Model%368927CA4068
//	/local/data/verisB/dorman/Xspec/src/model
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/UniqueEnergy.cxx

//## begin module%43A8601201D1.additionalIncludes preserve=no
//## end module%43A8601201D1.additionalIncludes

//## begin module%43A8601201D1.includes preserve=yes
//## end module%43A8601201D1.includes

// UniqueEnergy
#include <XSModel/Model/UniqueEnergy.h>
//## begin module%43A8601201D1.declarations preserve=no
//## end module%43A8601201D1.declarations

//## begin module%43A8601201D1.additionalDeclarations preserve=yes
#include <XSUtil/Error/Error.h>
//## end module%43A8601201D1.additionalDeclarations


// Class UniqueEnergy 

UniqueEnergy::UniqueEnergy (const RealArray& energies)
  //## begin UniqueEnergy::UniqueEnergy%43A864080195.hasinit preserve=yes
  :m_energy(energies),
   m_clientSpectra(),
   m_associatedGain(),
   m_dontShare(false)
  //## end UniqueEnergy::UniqueEnergy%43A864080195.hasinit
  //## begin UniqueEnergy::UniqueEnergy%43A864080195.initialization preserve=yes
  //## end UniqueEnergy::UniqueEnergy%43A864080195.initialization
{
  //## begin UniqueEnergy::UniqueEnergy%43A864080195.body preserve=yes
  //## end UniqueEnergy::UniqueEnergy%43A864080195.body
}


UniqueEnergy::~UniqueEnergy()
{
  //## begin UniqueEnergy::~UniqueEnergy%43A861BA02A8_dest.body preserve=yes
  //## end UniqueEnergy::~UniqueEnergy%43A861BA02A8_dest.body
}



//## Other Operations (implementation)
void UniqueEnergy::addClient (size_t specNum)
{
  //## begin UniqueEnergy::addClient%43A867DC0378.body preserve=yes
   if (m_dontShare)
   {
      throw RedAlert("Attempting to add client to a no-share UniqueEnergy.");
   }
   m_clientSpectra.insert(specNum);
  //## end UniqueEnergy::addClient%43A867DC0378.body
}

bool UniqueEnergy::removeClient (size_t specNum)
{
  //## begin UniqueEnergy::removeClient%43A867EF0252.body preserve=yes
   m_clientSpectra.erase(specNum);
   return m_clientSpectra.empty();
  //## end UniqueEnergy::removeClient%43A867EF0252.body
}

void UniqueEnergy::changeEnergy (const RealArray& newEnergy)
{
  //## begin UniqueEnergy::changeEnergy%44119C2E01ED.body preserve=yes
   // One should be very careful about using this function.  It's
   // original intended use is for shifting gain parameters during
   // a fit, and where clientSpectra should only be size of one.
   if (m_clientSpectra.size() > 1)
   {
      throw RedAlert("Cannot modify UniqueEnergy array that has more than 1 client spectrum.");      
   }
   if (m_energy.size() != newEnergy.size())
      m_energy.resize(newEnergy.size());
   m_energy = newEnergy;
  //## end UniqueEnergy::changeEnergy%44119C2E01ED.body
}

// Additional Declarations
  //## begin UniqueEnergy%43A861BA02A8.declarations preserve=yes
  //## end UniqueEnergy%43A861BA02A8.declarations

//## begin module%43A8601201D1.epilog preserve=yes
//## end module%43A8601201D1.epilog
